﻿;==============================================================================================================================================================================
; Multiple file import
;==============================================================================================================================================================================

Procedure.i ExtractFoodDateExchangeCompressedFile(ImportFileName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected ResultFlag.i, PackHandle.i
  
  ;------------------------------------------------------------------------------------------------
  ; If the user didn't cancel, do the code below
  ;------------------------------------------------------------------------------------------------
 
  PackHandle.i = OpenPack(#PB_Any, ImportFileName.s, #PB_PackerPlugin_Zip)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If PackHandle.i <> #NoFileHandle
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If ExaminePack(PackHandle.i)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ResultFlag = #True
      
      ;--------------------------------------------------------------------------------------------
      ; To be sure that nothing is accidently left
      ;--------------------------------------------------------------------------------------------
      
      If FileSize(Program\TemporaryDirectory + "Unpacked\") = #FileIsDirectory
      
        DeleteDirectory(Program\TemporaryDirectory + "Unpacked\", #EmptyString, #PB_FileSystem_Recursive)
      
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If CreateDirectory(Program\TemporaryDirectory + "Unpacked\")
        
        While NextPackEntry(PackHandle.i) And ResultFlag
          
          If PackEntryType(PackHandle.i) = #PB_Packer_Directory
            
            ;--------------------------------------------------------------------------------------
            ; Debug "Directory:     " + TemporaryDirectory.s  + PackEntryName(PackHandle.i)
            ;--------------------------------------------------------------------------------------
            
            If CreateDirectory(Program\TemporaryDirectory + "Unpacked\" + GetPathPart(PackEntryName(PackHandle.i))) = #DirectoryNotCreated
              
              ResultFlag = #False
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          ElseIf PackEntryType(PackHandle.i) = #PB_Packer_File
            
            ;--------------------------------------------------------------------------------------
            ; Debug "File: " + TemporaryDirectory.s  + PackEntryName(PackHandle.i)
            ;--------------------------------------------------------------------------------------
            
            If UncompressPackFile(PackHandle.i, Program\TemporaryDirectory + "Unpacked\" + PackEntryName(PackHandle.i)) = #FileNotDecompressed
              
              ;------------------------------------------------------------------------------------
              ; Debug "File failed to be decompressed"
              ;------------------------------------------------------------------------------------
              
              ResultFlag = #False
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Wend
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      Debug "Packed file could not be examined"
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ClosePack(PackHandle.i)
    
    ;----------------------------------------------------------------------------------------------
    ; Process the XML file "Data.XML" in the current directory
    ;----------------------------------------------------------------------------------------------
    
    If ResultFlag
      
      ImportFoodDataExchangeCompressedFile(ImportFileName.s, Program\TemporaryDirectory + "Unpacked\" + "Data.xml")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If FileSize(Program\TemporaryDirectory + "Unpacked\") = #FileIsDirectory
      
      DeleteDirectory(Program\TemporaryDirectory + "Unpacked\", #EmptyString, #PB_FileSystem_Recursive)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    Debug "The specified packed file could not be opened"
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ;   
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn ResultFlag
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 67
; FirstLine = 38
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP
; HideErrorLog
; CompileSourceDirectory