﻿;==============================================================================================================================================================================
; Master recipe import control routine
;==============================================================================================================================================================================

Procedure ImportFiles()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected.s Ext1.s, Ext2.s, Ext3.s, Ext4.s, Ext5.s, Ext6.s, Ext7.s, Ext8.s, ExtensionsString.s
  
  Protected.s ImportFileName.s
  
  Protected.i ImportPatternType.i
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Ext1.s  = "Food Data Exchange compressed (*.fdxz)|*.fdxz|"  ; Food Data Exchange Compressed
  
  Ext2.s  = "Food Data Exchange (*.fdx)|*.fdx|"               ; Food Data Exchange
  
  Ext3.s  = "MasterCook I (*.mxp)|*.mxp|"                     ; MasterCook
  
  Ext4.s  = "MasterCook II (*.mx2)|*.mx2|"                    ; MasterCook II
  
  Ext5.s  = "MealMaster MMF (*.mmf)|*.mmf|"                   ; MealMaster
  
  Ext6.s  = "Now You're Cooking (*.nyc)|*.nyc|"               ; Now You're Cooking
  
  Ext7.s  = "RecipeML (*.xml;*.recipeml)|*.xml;*.recipeml|"   ; RecipeML
  
  Ext8.s  = "BigOven (*.crb)|*.crb"                           ; BigOven
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ExtensionsString.s  = Ext1.s + Ext2.s + Ext3.s + Ext4.s + Ext5.s + Ext6.s + Ext7.s + Ext8.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ImportFileName.s   = OpenFileRequester("Import file from", #EmptyString, ExtensionsString.s, 0, #PB_Requester_MultiSelection)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ImportPatternType.i = SelectedFilePattern()
  
  ;------------------------------------------------------------------------------------------------
  ; Enable the below if you want to be able to select multiple files
  ;------------------------------------------------------------------------------------------------
  
  While ImportFileName.s
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    DatabaseUpdate(Program\DatabaseHandle, "Begin Transaction")
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Select ImportPatternType.i
        
      Case 0  : ExtractFoodDateExchangeCompressedFile(ImportFileName.s)                           ; "Food Data Exchange compressed (*.fdxz)|*.fdxz|"
        
      Case 1  : ImportFoodDataExchangeFile(ImportFileName.s)                                      ; "Food Data Exchange (*.fdx)|*.fdx|"
        
      Case 2  : ImportMasterCookIFile(ImportFileName.s)                                           ; "MasterCook I (*.mxp)|*.mxp|"
        
      Case 3  : ImportMasterCookIIFile(ImportFileName.s)                                          ; "MasterCook II (*.mx2)|*.mx2|"
        
      Case 4  : ImportMealMasterFile(ImportFileName.s)                                            ; "MealMaster MMF (*.mmf)|*.mmf|"
        
      Case 5  : ImportNowYoureCookingFile(ImportFileName.s)                                       ; "Now You're Cooking (*.nyc)|*.nyc|"
        
      Case 6  : ImportRecipeMLFile(ImportFileName.s)                                              ; "RecipeML (*.xml;*.recipeml)|*.xml;*.recipeml"
        
      Case 7  : ImportBigOvenFile(ImportFileName.s)                                               ; "BigOven (*.crb)|*.crb"
        
    EndSelect
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ImportFileName.s = NextSelectedFileName()
    
    ;----------------------------------------------------------------------------------------------
    ; Commit All the SQL transactions to the database
    ;----------------------------------------------------------------------------------------------
    
    DatabaseUpdate(Program\DatabaseHandle, "Commit")
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Wend
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 100
; FirstLine = 45
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP