﻿;==============================================================================================================================================================================
; Import the Food Data Exchange recipe
;==============================================================================================================================================================================

Procedure ImportFoodDataExchangeCompressedFile(ImportFileName.s, DataFileName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected.i XMLDataHandle.i, RecipeDataExchangeFile
  
  Protected RecipeDataExchangeFileSize.q, FileNameOnly.s
  
  Protected *Buffer, *Node
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  FileNameOnly.s  = GetFilePart(ImportFileName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; Count the old number of items in the display
  ;------------------------------------------------------------------------------------------------
  
  RecipeDataExchangeFile.i = ReadFile(#PB_Any, DataFileName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If RecipeDataExchangeFile.i <> 0
    
    ;----------------------------------------------------------------------------------------------
    ; Show the currently processed file on the import window title bar
    ;----------------------------------------------------------------------------------------------
    
    RecipeDataExchangeFileSize.q = Lof(RecipeDataExchangeFile.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If RecipeDataExchangeFileSize.q
      
      *Buffer = AllocateMemory(RecipeDataExchangeFileSize.q)
      
      If *Buffer
        
        If ReadData(RecipeDataExchangeFile, *Buffer, RecipeDataExchangeFileSize.q) = RecipeDataExchangeFileSize.q
          
          XMLDataHandle.i = CatchXML(#PB_Any, *Buffer, RecipeDataExchangeFileSize.q)
          
          If XMLDataHandle.i
            
            If XMLStatus(XMLDataHandle.i) = #PB_XML_Success
              
              *Node = MainXMLNode(XMLDataHandle.i)
              
              If *Node
                
                ImportFoodDataExchangeCompressedFile_XML(ImportFileName.s, DataFileName.s, *Node, 0)
                
              EndIf
              
            Else
              
              Debug "The XML data from  " + FileNameOnly.s  + " is faulty. File renamed to : " + FileNameOnly.s  + ".BadXML"
              
              If Not RenameFile(ImportFileName.s, ImportFileName.s  + ".BadXML")  <> 0
                
                Debug "Fauly recipe file: " + FileNameOnly  + " could not be renamed to:  " + FileNameOnly.s  + ".BadXML"
                
              EndIf
              
            EndIf
            
            FreeXML(XMLDataHandle.i)
            
          EndIf
          
        EndIf
        
        FreeMemory(*Buffer)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      Debug "File is empty, cannot allocate memory for it."
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CloseFile(RecipeDataExchangeFile.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    Debug "File wasn't opened, so there is file handle."
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 20
; FirstLine = 16
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP
; CompileSourceDirectory