﻿;==============================================================================================================================================================================
; Import a MasterCook recipe dump into Recipes
;==============================================================================================================================================================================

Procedure ImportMasterCookIFile(ImportFileName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected.i State, Position, RecipeFileHandle.i
  
  Protected   Line.s, Title.s, Source.s, Categories.s, Serves.s, Ingredients.s, Instructions.s
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  RecipeFileHandle.i = ReadFile(#PB_Any,  ImportFileName.s)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If RecipeFileHandle.i
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    While Not Eof(RecipeFileHandle.i)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Line.s = ReadString(RecipeFileHandle.i)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Select State
          
        Case 0
          
          If FindString(Line.s, "*  Exported")
            
            ClearRecipeStructure()
            
            State + 1
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case 1
          
          If Line.s <> #EmptyString
            
            Recipe\Recipetitle.s   = Trim(Line.s)
            
            Recipe\Recipetitle.s   = ReplaceString(Recipe\Recipetitle.s, "'", "''")
            
            Recipe\Recipetitle.s   = ProperCaseString(Recipe\Recipetitle.s)               
            
            State + 1
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case 2
          
          Position = FindString(Line.s, "Recipe By     :")
          
          If Position
            
            Recipe\Recipesource    = Trim(Mid(Line.s, Position + 15))
            
            Recipe\Recipesource.s  = ReplaceString(Recipe\Recipesource.s, "'", "''")
            
            State + 1
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ;
          ;----------------------------------------------------------------------------------------
          
        Case 3
          
          Position = FindString(Line.s, "Serving Size  :")
          
          If Position
            
            Recipe\Numberofservings = Str(Val(Mid(Line.s, Position + 15)))
            
            State + 1
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ;
          ;----------------------------------------------------------------------------------------
          
        Case 4
          
          Position = FindString(Line.s, "Categories    :")
          
          If Position
            
            Line.s = Mid(Line.s,  Position + 15)
            
            Recipe\Categories + Trim(Left(Line.s, 33))
            
            Line.s = Trim(Mid(Line.s, 33))
            
            If Line.s <> #EmptyString
              
              Recipe\Categories + "," + Line.s
              
            EndIf
            
            State + 1
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ;
          ;----------------------------------------------------------------------------------------
          
        Case 5
          
          Position = FindString(Line.s, "Amount")
          
          If Position
            
            State + 1
            
          Else
            
            Line.s = Trim(Line.s)
            
            If Line.s <> #EmptyString
              
              Recipe\Categories + "," + Trim(Left(Line.s, 33))
              
              Line.s = Trim(Mid(Line.s, 33))
              
              If Line.s <> #EmptyString
                
                Recipe\Categories + "," + Line.s
                
              EndIf
              
            EndIf
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ;
          ;----------------------------------------------------------------------------------------
          
        Case 6
          
          If Line.s = #EmptyString
            
            ;Recipe\Ingredients = Trim(Recipe\Ingredients, "|")
            
            State + 1
            
          Else
            
            If Left(Line.s, 1) <> "-"
              
              AddElement(Recipe\IngredientList())
              
              Recipe\IngredientList()\Unit        = Trim(Left(Line.s,      8))
              
              Recipe\IngredientList()\Measure     = Trim(Mid(Line.s, 11,  12))
              
              Recipe\IngredientList()\Measure     = CorrectIngredientMeasure(Recipe\IngredientList()\Measure)  ; Corrent single letetr ingredient measure strings
              
              Recipe\IngredientList()\Ingredient  = Trim(Mid(Line.s,      25))
              
            EndIf
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case 7
          
          If FindString(Line.s, "- - - -")
            
            Recipe\Instructions.s = ReplaceString(Recipe\Instructions.s, "'", "''")
            
            Recipe\Categories.s   = ReplaceString(Recipe\Categories.s,   "'", "''")
            
            SaveImportRecipe("MasterCook")
            
            ClearRecipeStructure()
            
            State = 0
            
          Else
            
            Recipe\Instructions.s + RecipeCRLFSpaceTrim(Line.s) + #LF$
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CloseFile(RecipeFileHandle.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    Debug "File wasn't opened, no there is file handle."
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure




; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 204
; FirstLine = 197
; Folding = -
; EnableXP