﻿;==============================================================================================================================================================================
; Import the Now You're Cooking recipe
;==============================================================================================================================================================================

Procedure.i ImportNowYoureCookingFile(ImportFileName.s)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  Protected.i State, Pos, Help, RecipeFileHandle.i
  
  Protected   Line.s, TemporaryString.s 
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  RecipeFileHandle.i = ReadFile(#PB_Any,  ImportFilename.s)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If RecipeFileHandle.i
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    While Not Eof(RecipeFileHandle.i)
    
      Line.s = ReadString(RecipeFileHandle.i)
      
      Select State

        Case 0
          
          If Left(Line.s, 5) = "@@@@@"
            
            ClearRecipeStructure()
            
            State + 1
            
          EndIf
          
        Case 1
          
          If Trim(Line.s) <> ""
            
            Recipe\Recipetitle.s  = Trim(Line.s)
            
            Recipe\Recipetitle.s  = ReplaceString(Recipe\Recipetitle.s, "'", "''")
              
            Recipe\Recipetitle.s  = ProperCaseString(Recipe\Recipetitle.s)               
            
            State + 1
            
          EndIf
          
        Case 2
          
          If Trim(Line.s) <> ""
            
            Recipe\Subcategories = RemoveString(Line.s, " ")
            
            Help = #False
            
            State + 1
            
          EndIf
          
        Case 3
          
          If Trim(Line.s) = ""
            
            If Help
              
              ;Recipe\Ingredients = Trim(Recipe\Ingredients, " ")
              
              State + 1
              
            Else
              
              Help = #True
              
            EndIf
            
          Else
            
            AddElement(Recipe\IngredientList())
        
            TemporaryString.s                   = ImportNowYoureCookingIngredient(Line.s)
            
            Recipe\IngredientList()\Unit        = StringField(TemporaryString.s, 1, "~")
        
            Recipe\IngredientList()\Measure     = StringField(TemporaryString.s, 2, "~")
            
            Recipe\IngredientList()\Measure     = CorrectIngredientMeasure(Recipe\IngredientList()\Measure)  ; Correct single letter ingredient measure strings
            
            Recipe\IngredientList()\Ingredient  = StringField(TemporaryString.s, 3, "~")
            
          EndIf
          
        Case 4
          
          If Left(Line.s, 6) = "Yield:"
            
            Recipe\Numberofservings = Str(Val(Mid(Line.s, 7)))
            
            State + 1
            
          Else
            
            Recipe\Instructions + ReplaceString(RecipeCRLFSpaceTrim(Line.s), "'", "''") + #LF$

          EndIf
          
        Case 5
          
          If Left(Line.s, 16) = "** Exported from"
            
            SaveImportRecipe("Now You're Cooking")
            
            ClearRecipeStructure()
            
            State = 0
            
          EndIf
          
      EndSelect
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CloseFile(RecipeFileHandle.i)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    Debug "File wasn't opened, no there is file handle."
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 64
; FirstLine = 38
; Folding = -
; EnableXP