﻿;==============================================================================================================================================================================
; Import a RecipeML XML file format
;==============================================================================================================================================================================

Procedure ImportRecipeMLFile(ImportFileName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected.i XML.i, RecipeMLFile.i
  
  Protected.q RecipeMLSize
  
  Protected   *Buffer, *Node
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  RecipeMLFile.i = ReadFile(#PB_Any, ImportFilename.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If RecipeMLFile.i
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    RecipeMLSize.q = Lof(RecipeMLFile.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    *Buffer = AllocateMemory(RecipeMLSize.q)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If *Buffer
      
      If ReadData(RecipeMLFile.i, *Buffer, RecipeMLSize.q) = RecipeMLSize.q
        
        XML = CatchXML(#PB_Any, *Buffer, RecipeMLSize.q)
        
        If XML
          
          *Node = MainXMLNode(XML)
          
          If *Node
            
            ImportRecipeMLFile_XML(ImportFileName.s, *Node, 0)
            
          EndIf
          
          FreeXML(XML)
          
          Recipe\Categories   = Trim(Recipe\Categories,  ",")
          
          SaveImportRecipe(ImportFileName.s)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          ClearRecipeStructure()
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        EndIf
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      FreeMemory(*Buffer)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CloseFile(RecipeMLFile.i)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    ; Debug "File wasn't opened, no there is file handle."
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 85
; FirstLine = 60
; Folding = -
; EnableXP